unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ClipBrd;

type
  TForm1 = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    Zeichne1: TMenuItem;
    SchreibeText1: TMenuItem;
    KopiereindieZwischenablage1: TMenuItem;
    Schliessen1: TMenuItem;
    AnzahlderSterne1: TMenuItem;
    Schriftgre1: TMenuItem;
    procedure Zeichne1Click(Sender: TObject);
    procedure Schliessen1Click(Sender: TObject);
    procedure KopiereindieZwischenablage1Click(Sender: TObject);
    procedure SchreibeText1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure AnzahlderSterne1Click(Sender: TObject);
    procedure Schriftgre1Click(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  Schriftgroesse,
  Anzahl: integer;

implementation

{$R *.DFM}


Procedure zeichne(a,b,x,y:integer);
  const skalierung = 1000;
        //Fnfeck: alle Punkte berechnet               A
        a1 =  000; //                                 / \
        a2 =  382; // (auf dem Kopf stehend)         /   \
        b1 = -364; //                            .  G     F .
        b2 =  118; //                       B '                ' E
        c1 = -225; //                         \        M(0|0) /
        c2 = -310; //                           \            /
        d1 =  225; //                             H         K
        d2 = -310; //                             /         \
        e1 =  364; //                            /     I     \
        e2 =  118; //                           /   /    \    \
        //Punkte im Fnfeckstern dazwischen    C /         \  D
        f1 =  086;
        f2 =  118;
        g1 = -086;
        g2 =  118;
        h1 = -139;
        h2 = -045;
        i1 =  000;
        i2 = -117;
        k1 =  139;
        k2 = -045;
  var points: array of Tpoint;
begin
  setlength(points,11);
  points[0].x := x + a*a1 div skalierung;
  points[0].y := y + a*a2 div skalierung;
  points[1].x := x + b*g1 div skalierung;
  points[1].y := y + b*g2 div skalierung;
  points[2].x := x + a*b1 div skalierung;
  points[2].y := y + a*b2 div skalierung;
  points[3].x := x + b*h1 div skalierung;
  points[3].y := y + b*h2 div skalierung;
  points[4].x := x + a*c1 div skalierung;
  points[4].y := y + a*c2 div skalierung;
  points[5].x := x + b*i1 div skalierung;
  points[5].y := y + b*i2 div skalierung;
  points[6].x := x + a*d1 div skalierung;
  points[6].y := y + a*d2 div skalierung;
  points[7].x := x + b*k1 div skalierung;
  points[7].y := y + b*k2 div skalierung;
  points[8].x := x + a*e1 div skalierung;
  points[8].y := y + a*e2 div skalierung;
  points[9].x := x + b*f1 div skalierung;
  points[9].y := y + b*f2 div skalierung;
  points[10].x :=  points[0].x;
  points[10].y :=  points[0].y;
  with form1.Image1.Canvas do Begin
    moveTo(points[0].x,points[0].y);
    brush.Color := clwhite;
    Polygon(Points); //Polyline(Points);
    {textout(x,y,'M');
    textout(points[0].x,points[0].y,'A');
    textout(points[1].x,points[1].y,'G');
    textout(points[2].x,points[2].y,'B');
    textout(points[3].x,points[3].y,'H');
    textout(points[4].x,points[4].y,'C');
    ...}
  End;
end;



procedure TForm1.Zeichne1Click(Sender: TObject);
      var  k, x, y, a, b: integer;
begin
  randomize;
  with image1.Canvas do Begin
    brush.Color := $00B3ECFD;
    rectangle(0,0,clientwidth,clientheight);
    pen.Color := $00040BF7;
    for k := 1 to Anzahl do BEgin
      a := random(200);
      b := a div (random(3) + 1);
      x := random(clientwidth - 2*a) + a;
      y := random(clientheight - 2*a) + a;
      zeichne(a,b,x,y);
    ENd;
  End;
end;


procedure TForm1.Schliessen1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.KopiereindieZwischenablage1Click(Sender: TObject);
  var  Bitmap: TBitmap;
begin
  Bitmap := TBitmap.Create;
  Bitmap.Width := image1.Width;
  Bitmap.Height := image1.Height;
  try
    with Bitmap.Canvas do
      CopyRect(ClientRect, Canvas, ClientRect);
               Clipboard.Assign(Bitmap);
  finally Bitmap.Free; end;
end;

procedure TForm1.SchreibeText1Click(Sender: TObject);
begin
  showmessage('Klicke aufs Bild und schreibe dann');
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
   var s: string;
begin
    s := InputBox('Text', 'Bitte geben Sie einen Text ein', 'Frhliche Weihnachten');
    with image1.Canvas do Begin
      font.Name := 'Comic Sans MS';
      font.Size := Schriftgroesse;
      font.Color := clred;
      image1.Canvas.TextOut(x,y,s);
    End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Anzahl := 300;
  Schriftgroesse := 24;
end;

procedure TForm1.AnzahlderSterne1Click(Sender: TObject);
begin
   Anzahl := StrToInt(
    Inputbox('Anzahl der Sterne','Geben Sie eine Zahl ein','10'));
end;

procedure TForm1.Schriftgre1Click(Sender: TObject);
begin
 Schriftgroesse := StrToInt(
    Inputbox('Schriftgre','Geben Sie eine Zahl ein','36'));
end;

end.

